com.tibbo.aggregate.common.expression

## Class ExpressionUtils

- java.lang.Object
- - com.tibbo.aggregate.common.expression.ExpressionUtils

-     public class ExpressionUtils
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `NULL_PARAM`
    `static char` | `PARAM_ESCAPE_DOUBLE`
    `static char` | `PARAM_ESCAPE_SINGLE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ExpressionUtils()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `copyAttributes(AttributedObject source, AttributedObject destination)`
    `static java.util.LinkedHashSet<Reference>` | `deduplicateExpressionsReferences(java.util.List<java.lang.String> expressions)`
    `static void` | `dump(java.lang.String expression)`
    `static java.lang.String` | `escapeStringLiteral(java.lang.String text)`
    `static java.lang.Object` | `findFieldValueByReference(Reference ref, DataTable table, java.lang.Integer defaultRowIndex)`
    `static java.util.List<Reference>` | `findReferences(Expression expression)`
    `static long` | `generateBindingId()`
    `static java.lang.String` | `getFunctionParameters(java.util.List<java.lang.Object> params)`
    `static java.util.List<java.lang.Object>` | `getFunctionParameters(java.lang.String paramsString, boolean allowExpressions)`
    `static java.lang.Object` | `getValue(AttributedObject ao)`
    `static ASTStart` | `parse(Expression expression, boolean showExpressionInErrorText)`
    `static ASTStart` | `parse(java.lang.String expressionText, boolean showExpressionInErrorText)`
    `static TableFormat` | `readFormat(java.lang.String format)`
    `static AttributedObject` | `toAttributed(java.lang.Object value)`
    `static AttributedObject` | `toAttributed(java.lang.Object value, AttributedObject source)`
    `static AttributedObject` | `toAttributed(java.lang.Object value, AttributedObject first, AttributedObject second)`
    `static boolean` | `useVisibleSeparators(java.lang.String formatString)`
    `static void` | `validateSyntax(Expression expression, boolean showExpressionInErrorText)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### PARAM_ESCAPE_SINGLE

          public static final char PARAM_ESCAPE_SINGLE

      See Also:
        Constant Field Values

    - #### PARAM_ESCAPE_DOUBLE

          public static final char PARAM_ESCAPE_DOUBLE

      See Also:
        Constant Field Values

    - #### NULL_PARAM

          public static final java.lang.String NULL_PARAM

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### ExpressionUtils

          public ExpressionUtils()

  - ### Method Detail

    - #### getValue

          public static java.lang.Object getValue(AttributedObject ao)

    - #### toAttributed

          public static AttributedObject toAttributed(java.lang.Object value)

    - #### toAttributed

          public static AttributedObject toAttributed(java.lang.Object value,
                                                      AttributedObject source)

    - #### toAttributed

          public static AttributedObject toAttributed(java.lang.Object value,
                                                      AttributedObject first,
                                                      AttributedObject second)

    - #### copyAttributes

          public static void copyAttributes(AttributedObject source,
                                            AttributedObject destination)

    - #### validateSyntax

          public static void validateSyntax(Expression expression,
                                            boolean showExpressionInErrorText)
                                     throws SyntaxErrorException

      Throws:
        `SyntaxErrorException`

    - #### getFunctionParameters

          public static java.util.List<java.lang.Object> getFunctionParameters(java.lang.String paramsString,
                                                                               boolean allowExpressions)

    - #### getFunctionParameters

          public static java.lang.String getFunctionParameters(java.util.List<java.lang.Object> params)

    - #### dump

          public static void dump(java.lang.String expression)
                           throws SyntaxErrorException

      Throws:
        `SyntaxErrorException`

    - #### parse

          public static ASTStart parse(Expression expression,
                                       boolean showExpressionInErrorText)
                                throws SyntaxErrorException

      Throws:
        `SyntaxErrorException`

    - #### parse

          public static ASTStart parse(java.lang.String expressionText,
                                       boolean showExpressionInErrorText)
                                throws SyntaxErrorException

      Throws:
        `SyntaxErrorException`

    - #### findReferences

          public static java.util.List<Reference> findReferences(Expression expression)
                                                          throws SyntaxErrorException

      Throws:
        `SyntaxErrorException`

    - #### deduplicateExpressionsReferences

          public static java.util.LinkedHashSet<Reference> deduplicateExpressionsReferences(java.util.List<java.lang.String> expressions)
                                                                                     throws SyntaxErrorException

      Throws:
        `SyntaxErrorException`

    - #### escapeStringLiteral

          public static java.lang.String escapeStringLiteral(java.lang.String text)

    - #### generateBindingId

          public static long generateBindingId()

    - #### readFormat

          public static TableFormat readFormat(java.lang.String format)
                                        throws SyntaxErrorException

      Throws:
        `SyntaxErrorException`

    - #### useVisibleSeparators

          public static boolean useVisibleSeparators(java.lang.String formatString)
                                              throws SyntaxErrorException

      Throws:
        `SyntaxErrorException`

    - #### findFieldValueByReference

          @Nullable
          public static java.lang.Object findFieldValueByReference(Reference ref,
                                                                              DataTable table,
                                                                              java.lang.Integer defaultRowIndex)